type DownloadClientType =
    'QBITTORRENT' |
    'DELUGE_V1' |
    'DELUGE_V2' |
    'RADARR' |
    'SONARR' |
    'LIDARR';

interface DownloadClientRules {
  enabled: boolean;
  max_active_downloads: number;
  ignore_slow_torrents: boolean;
  download_speed_threshold: number;
}

interface DownloadClientBasicAuth {
  auth: boolean;
  username: string;
  password: string;
}

interface DownloadClientSettings {
  apikey?: string;
  basic?: DownloadClientBasicAuth;
  rules?: DownloadClientRules;
}

interface DownloadClient {
  id?: number;
  id: number;
  name: string;
  type: DownloadClientType;
  enabled: boolean;
  host: string;
  port: number;
  ssl: boolean;
  username: string;
  password: string;
  settings?: DownloadClientSettings;
}